/*
 * Copyright (c) 1996 Barton P. Miller
 * 
 * We provide the Paradyn Parallel Performance Tools (below
 * described as Paradyn") on an AS IS basis, and do not warrant its
 * validity or performance.  We reserve the right to update, modify,
 * or discontinue this software at any time.  We shall have no
 * obligation to supply such updates or modifications or any other
 * form of support to you.
 * 
 * This license is for research uses.  For such uses, there is no
 * charge. We define "research use" to mean you may freely use it
 * inside your organization for whatever purposes you see fit. But you
 * may not re-distribute Paradyn or parts of Paradyn, in any form
 * source or binary (including derivatives), electronic or otherwise,
 * to any other organization or entity without our permission.
 * 
 * (for other uses, please contact us at paradyn@cs.wisc.edu)
 * 
 * All warranties, including without limitation, any warranty of
 * merchantability or fitness for a particular purpose, are hereby
 * excluded.
 * 
 * By your use of Paradyn, you understand and agree that we (or any
 * other person or entity with proprietary rights in Paradyn) are
 * under no obligation to provide either maintenance services,
 * update services, notices of latent defects, or correction of
 * defects for Paradyn.
 * 
 * Even if advised of the possibility of such damages, under no
 * circumstances shall we (or any other person or entity with
 * proprietary rights in the software licensed hereunder) be liable
 * to you or any third party for direct, indirect, or consequential
 * damages of any character regardless of type of action, including,
 * without limitation, loss of profits, loss of use, loss of good
 * will, or computer failure or malfunction.  You agree to indemnify
 * us (and any other person or entity with proprietary rights in the
 * software licensed hereunder) for any and all liability it may
 * incur to third parties resulting from your use of Paradyn.
 */

/* 
 * FormatBoxP.h - Private definitions for Formatted box widget
 * 
 * $Log: FormatBoxP.h,v $
 * Revision 1.2  1996/08/16 19:03:30  tamches
 * updated copyright notice for release 1.1
 *
 * Revision 1.1  1994/03/31 18:10:55  krisna
 * implementation files for the Histogram widget
 *
 * Revision 1.1  1990/08/24  13:01:14  hollings
 * Initial revision
 *
 *
 */

#ifndef _XawFormatBoxP_h
#define _XawFormatBoxP_h

#include "FormatBox.h"
#include <X11/Xaw/BoxP.h>
#include <X11/CompositeP.h>
#include <X11/Xmu/Converters.h>

/* New fields for the Box widget class record */
typedef struct {int empty;} FormatClassPart;

/* Full class record declaration */
typedef struct _FormatBoxClassRec {
    CoreClassPart	core_class;
    CompositeClassPart  composite_class;
    BoxClassPart	box_class;
    FormatClassPart	format_class;
} FormatBoxClassRec;

extern FormatBoxClassRec formatBoxClassRec;

/* New fields for the Box widget record */
typedef struct {
    int		justify_mode;
    int		maximize;
} FormatBoxPart;


typedef struct _FormatBoxRec {
    CorePart	    core;
    CompositePart   composite;
    BoxPart 	    box;
    FormatBoxPart   format;
} FormatBoxRec;

/* formatting options */
#define XtFormatNone	0	/* default box behavior */
#define XtFormatCenter	1	/* center children, but don't re-space */
#define XtFormatJustify	2	/* full proportional spacing */

#endif 
